%define major 1
%define minor 3

%define realname QGLViewer

%define libname %mklibname %{realname} %{major}_%{minor}
%define libnamedev %mklibname %{realname} %{major}_%{minor} -d


Name:		libQGLViewer
Version:	%{major}.%{minor}.9
Release:	1mdk

Summary:	Qt based OpenGL generic 3D viewer library
License:	GPL
Group:		System/Libraries
Source:		http://artis.imag.fr/Members/Gilles.Debunne/QGLViewer/src/%{name}-%{version}.tar.bz2
URL:		http://artis.imag.fr/Members/Gilles.Debunne/QGLViewer
Buildroot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
A versatile 3D viewer library for 3D application development.
Features many useful classical functionalities such as a camera trackball,
screenshot savings, stereo display, (hierarchical) frames that can be moved
with the mouse, keyFrame interpolator...

%package -n %libname
Summary:        Qt based OpenGL generic 3D viewer library
License:        GPL
Group:          System/Libraries

%description  -n %libname
A versatile 3D viewer library for 3D application development.
Features many useful classical functionalities such as a camera trackball,
screenshot savings, stereo display, (hierarchical) frames that can be moved
with the mouse, keyFrame interpolator...

%package -n %libnamedev
Summary: The libQGLViewer header files, documentation and examples
Group: System/Libraries
Requires: %{libname} = %{version}

%description -n %libnamedev
This package contains the header files for libQGLViewer.
Install this package if you want to develop programs that uses 
libQGLViewer. A reference documentation and pedagogical
examples are included. 

%prep
%define docdir %_docdir/QGLViewer
%define includeDir %_includedir/QGLViewer
%define libdir %_libdir
%setup
  
%build
cd QGLViewer

if [[ -z "${QTDIR}" ]]
then
  if [[ -d %_libdir/qt3 ]]
  then
    export QTDIR=%_libdir/qt3
  else
    echo "Trying to autodetect QTDIR..."
    autoDetect=`locate lib/libqt | head -1 | sed s:"/lib/libqt.*":"":`
    if [[ -d $autoDetect ]] 
    then
      export QTDIR=$autoDetect
    else
      echo "Compilation error - QTDIR is undefined, unable to run qmake"
      echo "Use export QTDIR=... ([ba]sh) or setenv QTDIR ... ([t]csh) and re-run"
      exit 1
    fi
  fi
fi

export PATH=${PATH}:${QTDIR}/bin
export LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:${QTDIR}/lib
qmake
make

%install
rm -rf $RPM_BUILD_ROOT
%{__install} -d $RPM_BUILD_ROOT%{includeDir}
%{__install} --mode=644 QGLViewer/*.h $RPM_BUILD_ROOT%{includeDir}
%{__install} -d $RPM_BUILD_ROOT%{includeDir}/cwFiles
%{__install} --mode=644 QGLViewer/*.cw $RPM_BUILD_ROOT%{includeDir}/cwFiles
#%{__install} --mode=644 QGLViewer/*.png $RPM_BUILD_ROOT%{includeDir}/cwFiles

%{__install} -d $RPM_BUILD_ROOT%{libdir}
%{__install} --mode=644 QGLViewer/libQGLViewer.so.%{version} $RPM_BUILD_ROOT%{libdir}
ln -s libQGLViewer.so.%{version} $RPM_BUILD_ROOT%{libdir}/libQGLViewer.so.%{major}.%{minor}
ln -s libQGLViewer.so.%{version} $RPM_BUILD_ROOT%{libdir}/libQGLViewer.so.%{major}
ln -s libQGLViewer.so.%{version} $RPM_BUILD_ROOT%{libdir}/libQGLViewer.so

# %{__install} -d $RPM_BUILD_ROOT%{_mandir}/man3
%{__install} -d $RPM_BUILD_ROOT%{docdir}
%{__install} -d $RPM_BUILD_ROOT%{docdir}/refManual
%{__install} -d $RPM_BUILD_ROOT%{docdir}/images
%{__install} -d $RPM_BUILD_ROOT%{docdir}/examples
%{__install} -d $RPM_BUILD_ROOT%{docdir}/examples/contribs
# %{__install} doc/man/man3/QGLViewer.3 $RPM_BUILD_ROOT%{_mandir}/man3/
# %{__install} doc/man/man3/qglviewer_* $RPM_BUILD_ROOT%{_mandir}/man3/
%{__install} --mode=644 doc/*.html doc/*.css $RPM_BUILD_ROOT%{docdir}
%{__install} --mode=644 INSTALL README LICENCE CHANGELOG $RPM_BUILD_ROOT%{docdir}
%{__install} --mode=644 doc/refManual/* $RPM_BUILD_ROOT%{docdir}/refManual
%{__install} --mode=644 doc/images/* $RPM_BUILD_ROOT%{docdir}/images
%{__install} --mode=644 doc/examples/*.html $RPM_BUILD_ROOT%{docdir}/examples
%{__install} --mode=644 examples/examples.pro $RPM_BUILD_ROOT%{docdir}/examples
%{__install} --mode=644 examples/contribs/contribs.pro $RPM_BUILD_ROOT%{docdir}/examples/contribs
for dir in `ls examples`
do
if [[ -d examples/$dir ]] && [[ $dir != "contribs" ]]
  then
    %{__install} -d $RPM_BUILD_ROOT%{docdir}/examples/$dir
    %{__install} --mode=644 examples/$dir/* $RPM_BUILD_ROOT%{docdir}/examples/$dir
  fi
done
for dir in `ls examples/contribs`
do
if [[ -d examples/contribs/$dir ]]
  then
    %{__install} -d $RPM_BUILD_ROOT%{docdir}/examples/contribs/$dir
    %{__install} --mode=644 examples/contribs/$dir/* $RPM_BUILD_ROOT%{docdir}/examples/contribs/$dir
  fi
done

%post -n %libname -p /sbin/ldconfig

%postun -n %libname -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files -n %libname
%defattr(-,root,root)
%{libdir}/*.so*


%files -n %libnamedev
%defattr(-,root,root)
%dir %{includeDir}
%{includeDir}/*.h
%dir %{includeDir}/cwFiles
%{includeDir}/cwFiles/*.cw
#%{includeDir}/cwFiles/*.png

# %doc %{_mandir}/man3/QGLViewer.3.bz2
# %doc %{_mandir}/man3/qglviewer_*

%dir %{docdir}
%doc %{docdir}/*.html
%doc %{docdir}/*.css
%doc %{docdir}/README
%doc %{docdir}/LICENCE
%doc %{docdir}/INSTALL
%doc %{docdir}/CHANGELOG
%dir %{docdir}/refManual
%doc %{docdir}/refManual/*
%dir %{docdir}/images
%doc %{docdir}/images/*
%dir %{docdir}/examples
%doc %{docdir}/examples/*
# %doc %{docdir}/examples/*.html
# %doc %{docdir}/examples/*.pro

%changelog
* Wed Dec 01 2004 Lenny Cartier <lenny@mandrakesoft.com> 1.3.9-1mdk
- 1.3.9
- and from Gilles Debunne <Gilles.Debunne@imag.fr>
	- - Minor bug fixes. Better MouseGrabber and MultiView examples. New sizeHint() method.

* Thu Sep 30 2004 Lenny Cartier <lenny@mandrakesoft.com> 1.3.8-3mdk
- rebuild

* Tue Jul 20 2004 Lenny Cartier <lenny@mandrakesoft.com> 1.3.8-2mdk
- from Gilles Debunne <Gilles.Debunne@imag.fr> : 
	- QAccel abandonned for key bindings. Library installed in /usr/lib instead of /usr/local/lib.


* Tue Jun 15 2004 Lenny Cartier <lenny@mandrakesoft.com> 1.3.8-1mdk
- 1.3.8

* Thu Feb 26 2004 Lenny Cartier <lenny@mandrakesoft.com> 1.3.6-1mdk
- from Gilles Debunne <Gilles.Debunne@imag.fr> :
	- Signal mechanism modified, MouseMotion renamed MouseAction, new project URL.

* Wed Jul 23 2003 Lenny Cartier <lenny@mandrakesoft.com> 1.3.4-1mdk
- from Gilles Debunne <Gilles.Debunne@imag.fr> : 
	- Mouse bindings configuration

* Wed Jun 25 2003 Gilles Debunne <Gilles.Debunne@imag.fr> 1.3.3-1
- Doxygen search engine, FAQ page, Z-buffer display, constraints in KFI.

* Mon May 5 2003 Gilles Debunne <Gilles.Debunne@imag.fr> 1.3.2-2
- /usr/lib changed to /usr/local/lib

* Thu Apr 17 2003 Gilles Debunne <Gilles.Debunne@imag.fr> 1.3.2-1
- help() uses popup windows. DLL created for windows.

* Wed Apr 10 2003 Gilles Debunne <Gilles.Debunne@imag.fr> 1.3.1-1
- A ManipulatedCameraFrame class. double in Quaternion.

* Wed Mar 26 2003 Gilles Debunne <Gilles.Debunne@imag.fr> 1.3.0-1
- Many changes in the API. Documentation updated. A new MouseGrabber class.

* Wed Mar 19 2003 Gilles Debunne <Gilles.Debunne@imag.fr> 1.2.9-3
- ORTHO camera improvements, better default help().

* Wed Mar 5 2003 Gilles Debunne <Gilles.Debunne@imag.fr> 1.2.9-2
- Slerp interpolation fixed. Tiny Camera matrix improvements.

* Wed Feb 26 2003 Gilles Debunne <Gilles.Debunne@imag.fr> 1.2.9-1
- No more camera referenceFrame, slerp interpolation and new install paths.

* Wed Jan 29 2003 Gilles Debunne <Gilles.Debunne@imag.fr> 1.2.8-3
- pixelGLRatio function, minor changes.

* Wed Jan 22 2003 Gilles Debunne <Gilles.Debunne@imag.fr> 1.2.8-2
- Minor bug fixes. GL state saving optimized.

* Wed Jan 15 2003 Gilles Debunne <Gilles.Debunne@imag.fr> 1.2.8-1
- SPECIAL key disappears. New trackball features.

* Thu Dec 12 2002 Gilles Debunne <Gilles.Debunne@imag.fr> 1.2.7-2
- Minor improvements, draw3DText. Mac and Windows compatible release.
- Documentation and examples added to the distribution.

* Wed Dec 4 2002 Gilles Debunne <Gilles.Debunne@imag.fr> 1.2.7-1
- KeyFrameInterpolator and EPSRender. Bug fixes and new trackball

* Thu Sep 10 2002 Gilles Debunne <Gilles.Debunne@imag.fr> 1.2.6-1
- New features and bug fixes. See CHANGELOG for details. Cleaner spec.

* Thu Jul 25 2002 Xavier Decoret <Xavier.Decoret@imag.fr> 1.2.5-2
- Links with qt-mt (multithread) so it works fine with Mandrake libqt3-devel
- fix the spec file: files were copied in /usr directories during rebuild!

* Tue Jul 16 2002 Gilles Debunne <Gilles.Debunne@imag.fr> 1.2.5-1
- First rpm release
